!
! MODULE uwerrors_op
!
! "THE BEER-WARE LICENSE":
! Alberto Ramos wrote this file. As long as you retain this 
! notice you can do whatever you want with this stuff. If we meet some 
! day, and you think this stuff is worth it, you can buy me a beer in 
! return. <alberto.ramos@cern.ch>
!
! file:    uwerrors_op.f90
! created: Mon Jul  2 03:27:24 2018
!                               

submodule (aderrors) aderrors_op

  implicit none
  
  

contains

! *****************************
! *
  module function less_t(a,b)
! *
! *****************************
    logical :: less_t
    type (uwreal), intent (in) :: a, b

    if (a%mean.lt.b%mean) then
       less_t = .true.
    else
       less_t = .false.
    end if
    
    return
  end function less_t

! *****************************
! *
  module function less_dr(a,b)
! *
! *****************************
    logical :: less_dr
    type (uwreal), intent (in)  :: a
    real (kind=DP), intent (in) :: b

    if (a%mean.lt.b) then
       less_dr = .true.
    else
       less_dr = .false.
    end if
    
    return
  end function less_dr

! *****************************
! *
  module function less_dl(b,a)
! *
! *****************************
    logical :: less_dl
    type (uwreal), intent (in)  :: a
    real (kind=DP), intent (in) :: b

    if (b.lt.a%mean) then
       less_dl = .true.
    else
       less_dl = .false.
    end if
    
    return
  end function less_dl

! *****************************
! *
  module function leq_t(a,b)
! *
! *****************************
    logical :: leq_t
    type (uwreal), intent (in) :: a, b

    if (a%mean.le.b%mean) then
       leq_t = .true.
    else
       leq_t = .false.
    end if
    
    return
  end function leq_t

! *****************************
! *
  module function leq_dr(a,b)
! *
! *****************************
    logical :: leq_dr
    type (uwreal), intent (in)  :: a
    real (kind=DP), intent (in) :: b

    if (a%mean.le.b) then
       leq_dr = .true.
    else
       leq_dr = .false.
    end if
    
    return
  end function leq_dr

! *****************************
! *
  module function leq_dl(b,a)
! *
! *****************************
    logical :: leq_dl
    type (uwreal), intent (in)  :: a
    real (kind=DP), intent (in) :: b

    if (b.le.a%mean) then
       leq_dl = .true.
    else
       leq_dl = .false.
    end if
    
    return
  end function leq_dl

! *****************************
! *
  module function gt_t(a,b)
! *
! *****************************
    logical :: gt_t
    type (uwreal), intent (in) :: a, b

    if (a%mean.gt.b%mean) then
       gt_t = .true.
    else
       gt_t = .false.
    end if
    
    return
  end function gt_t

! *****************************
! *
  module function gt_dr(a,b)
! *
! *****************************
    logical :: gt_dr
    type (uwreal), intent (in)  :: a
    real (kind=DP), intent (in) :: b

    if (a%mean.gt.b) then
       gt_dr = .true.
    else
       gt_dr = .false.
    end if
    
    return
  end function gt_dr

! *****************************
! *
  module function gt_dl(b,a)
! *
! *****************************
    logical :: gt_dl
    type (uwreal), intent (in)  :: a
    real (kind=DP), intent (in) :: b

    if (b.gt.a%mean) then
       gt_dl = .true.
    else
       gt_dl = .false.
    end if
    
    return
  end function gt_dl

! *****************************
! *
  module function geq_t(a,b)
! *
! *****************************
    logical :: geq_t
    type (uwreal), intent (in) :: a, b

    if (a%mean.ge.b%mean) then
       geq_t = .true.
    else
       geq_t = .false.
    end if
    
    return
  end function geq_t

! *****************************
! *
  module function geq_dr(a,b)
! *
! *****************************
    logical :: geq_dr
    type (uwreal), intent (in)  :: a
    real (kind=DP), intent (in) :: b

    if (a%mean.ge.b) then
       geq_dr = .true.
    else
       geq_dr = .false.
    end if
    
    return
  end function geq_dr

! *****************************
! *
  module function geq_dl(b,a)
! *
! *****************************
    logical :: geq_dl
    type (uwreal), intent (in)  :: a
    real (kind=DP), intent (in) :: b

    if (b.ge.a%mean) then
       geq_dl = .true.
    else
       geq_dl = .false.
    end if
    
    return
  end function geq_dl

! ********************************
! *
  subroutine submodule_error(routine, msg)
! *
! ********************************

    character (len=*), intent (in) :: routine, msg

    write(error_unit,*)'error '//trim(routine)// ':'
    write(error_unit,'(5x,1a)')trim(msg)
    write(error_unit,*)

    stop
  end subroutine submodule_error

  
end submodule aderrors_op
